#include <Math\Alglib\dataanalysis.mqh>
//+------------------------------------------------------------------+
#define _rand(min,max) ((rand()/(double)SHORT_MAX)*((max)-(min))+min)
//+------------------------------------------------------------------+
void OnStart()
{
   CMultilayerPerceptron net;
   CMLPReport            rep;
   CMatrixDouble         patterns;
  	double vector[2], out[1]; //
	int info;
	//  
	patterns.Resize(100,3);
   int m=0;	// first pattern
   for(int i=1; i<=10; i++)
      for(int j=1; j<=10; j++)
      {
         patterns[m].Set(0,i/10.0);			// input 1
         patterns[m].Set(1,j/10.0);			// input 2
         patterns[m].Set(2,(i*j)/100.0);	// target
         m++; //next pattern
      }
   //      (5 )
   CMLPBase::MLPCreate1(2,5,1,net);
   //  
	CMLPTrain::MLPTrainLM(net,patterns,100,1e-3,5,info,rep);	//Levenberg-Marquardt
	//CMLPTrain::MLPTrainLBFGS(net,paterns,100,1e-3,10,0.001,1000,info,rep);//L-BFGS
	Print("Info=",info,"  Error=",CMLPBase::MLPError(net,patterns,100));	
	//     
	string s=" 1 >> ";
   for(int i=1; i<=10; i++)
	{
		int d1=(int)_rand(1,10), d2=(int)_rand(1,10);
		vector[0]=d1/10.0;
		vector[1]=d2/10.0;
		CMLPBase::MLPProcess(net,vector,out);
		s+=(string)d1+"*"+(string)d2+"="+DoubleToString(out[0]*100,0)+" // ";
	}
	Print(s);
	//    x 
	s=" 2 >> ";
   for(int i=1; i<=5; i++)
	{
		double d1=NormalizeDouble(_rand(1,10),1), d2=NormalizeDouble(_rand(1,10),1);
		vector[0]=d1/10.0;
		vector[1]=d2/10.0;
		CMLPBase::MLPProcess(net,vector,out);
		s+=DoubleToString(d1,1)+"*"+DoubleToString(d2,1)+"="+DoubleToString(out[0]*100,2)+
			"("+DoubleToString(d1*d2,2)+") // ";
	}
	Print(s);
}
